/*

AloneViewer(v1.2.0) 2008-4-12
by whitecaps ( http://white-board-blog.seesaa.net/ )
(c) 2008 whitecaps
This script is under MIT license.

*/

//アプリケーション全体で使う変数の宣言

var loadfileurl;
var zoomlevel = 1.0;
var loadedfile;

//オープンダイアログボックスからSVGファイルを開く

function svgfileloadfropendiabox(event) {    
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.appendFilter("SVG File","*.svg");
    fp.init(window, "Select a File", nsIFilePicker.modeOpen);
    var res = fp.show();
    if (res == nsIFilePicker.returnOK){
        loadedfile = fp.file;
        loadfileurl = loadedfile.path;

        setsvgfiletosvgcanvas();

        document.getElementById("fileurlenterbox").value = loadfileurl;

        filesizestatusbardisplay();
        zoomlevelstatusbardisplay();
    }
}

//ファイルサイズをステータスバーに表示

function filesizestatusbardisplay(){
    var filesizedisplaypanelins = document.getElementById('filesizedisplaystatuspanel');
    var bytefilesize = loadedfile.fileSize + " byte";
    var kbfilesize = Math.round(loadedfile.fileSize/1024) + " KB";
    var filesizedbltext = kbfilesize + " ( " + bytefilesize + " ) ";

    filesizedisplaypanelins.setAttribute("value", filesizedbltext );
       
}

//パス名からSVGファイルを表示

function openloadfilewithurl(event){
    var loadfileurl = document.getElementById("fileurlenterbox").value;
    var svgcanvasins = document.getElementById('svgcanvas');
    svgcanvasins.setAttribute("src", "file://localhost" + loadfileurl);

    var loadedfilefrurl =
      Components.classes["@mozilla.org/file/local;1"].
      createInstance(Components.interfaces.nsILocalFile);
    loadedfilefrurl.initWithPath(loadfileurl);
    loadedfile = loadedfilefrurl;

    filesizestatusbardisplay();
}

//SVGファイルをiframeにセット

function setsvgfiletosvgcanvas() {
    resetzoom();
    var svgcanvasins = document.getElementById('svgcanvas');
    svgcanvasins.setAttribute("src", "file://localhost" + loadfileurl);    
}

//拡大

function zoomin(event){
    zoomlevel = zoomlevel*1.25;
    svgcanvaszoom();
}

//縮小

function zoomout(event){
    zoomlevel = zoomlevel*0.75;
    svgcanvaszoom();
}

//ズームをリセット

function resetzoom(){
    zoomlevel = 1.0;
    svgcanvaszoom();
}

//数値コントロールからズームをセット
function setzoomfrnum(){
    var zoomperlevel = document.getElementById("zoomlevelnumbox").value;
    zoomlevel = zoomperlevel * 0.01;
    svgcanvaszoom();
}

//ズーム

function svgcanvaszoom() {
    validzoomlevel();

    var iframe = document.getElementById("svgcanvas");
    var contViewer = iframe.docShell.contentViewer;
    var docViewer = contViewer.QueryInterface(Components.interfaces.nsIMarkupDocumentViewer);
    docViewer.fullZoom = zoomlevel;
    
    zoomlevelstatusbardisplay();
}

//ズーム倍率をステータスバーに表示

function zoomlevelstatusbardisplay() {
    var noroundedzoomperlevel = zoomlevel*100;
    var roundedzoomperlevel = Math.round(noroundedzoomperlevel);
    document.getElementById("zoomlevelnumbox").value = roundedzoomperlevel;
    document.getElementById("zoomscaler").value = roundedzoomperlevel;
}

//ズーム倍率を適切な値に限定する

function validzoomlevel() {
    if (zoomlevel > 20) {
    zoomlevel = 20;
    }    
    if (zoomlevel < 0.05) {
    zoomlevel = 0.05;
    }
    var noroundedzoomperlevel = zoomlevel*100;
    var roundedzoomperlevel = Math.round(noroundedzoomperlevel);
    zoomlevel = roundedzoomperlevel/100;    
}

//scaleでズームする
function zoomscale(event){
    var zoomperlevel = document.getElementById("zoomscaler").value;
    zoomlevel = zoomperlevel * 0.01;
    svgcanvaszoom();   
}
